<?php
// API doc : http://techbureau-api-document.readthedocs.io/ja/latest/public/2_individual/2_currency_pairs.html
// API url : https://api.zaif.jp/api/1/currency_pairs/{currency_pair}

// currency_pair api url
$zaif_api_url  = "https://api.zaif.jp/api/1/currency_pairs/";

// proxy settings
$proxy      = "";
$proxy_port = "";

$curl = curl_init();
if ($curl == FALSE) {
    fputs(STDERR, "[ERR] curl_init(): " . curl_error($curl) . PHP_EOL);
    die(1);
}

// curl set options
$currency = "all";  // all currency_pair
curl_setopt($curl, CURLOPT_URL, $zaif_api_url . $currency);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
// set proxy server settings
if (!empty($proxy) && !empty($proxy_port)) {
    curl_setopt($curl, CURLOPT_HTTPPROXYTUNNEL, 1);
    curl_setopt($curl, CURLOPT_PROXY, $proxy . ":" . $proxy_port);
    curl_setopt($curl, CURLOPT_PROXYPORT, $proxy_port);
}

// call currency_pair api
$response = curl_exec($curl);
if ($response == FALSE) {
    fputs(STDERR, "[ERR] curl_exec(): " . curl_error($curl) . PHP_EOL);
    die(1);
}
// json decode
$json_decode = json_decode($response, true);
if ($json_decode == NULL) {
    fputs(STDERR, "[ERR] json_decode(): " . json_last_error_msg() . PHP_EOL);
    die(1);
}
curl_close($curl);

// show currency_pairs
//print_r($json_decode);

// sort by id
foreach ($json_decode as $key => $value){
  $key_id[$key] = $value['id'];
}
array_multisort ($key_id , SORT_ASC , $json_decode);

// show currency_pairs
foreach ($json_decode as $cur_pair) {
    printf("id: %d" . PHP_EOL, $cur_pair["id"]);
    printf("seq: %d, title: %s" . PHP_EOL,
        $cur_pair["seq"], $cur_pair["title"]);
    printf("description: %s, item_japanese %s" . PHP_EOL,
        $cur_pair["description"], $cur_pair["item_japanese"]);
    printf("name: %s, currency_pair: %s" . PHP_EOL,
        $cur_pair["name"], $cur_pair["currency_pair"]);
    printf("item_unit_step: %f, item_unit_min: %f" . PHP_EOL,
        $cur_pair["item_unit_step"], $cur_pair["item_unit_min"]);
    printf("aux_unit_min: %d, aux_unit_step: %d, aux_unit_point: %d" . PHP_EOL,
        $cur_pair["aux_unit_min"], $cur_pair["aux_unit_step"], $cur_pair["aux_unit_min"]);
    printf("aux_japanese: %s, event_number: %d" . PHP_EOL,
        $cur_pair["aux_japanese"], $cur_pair["event_number"]);
    printf("is_token: %s" . PHP_EOL,
        ($cur_pair["is_token"] == TRUE ? "True" : "False"));
    print("----------------------------------------" . PHP_EOL);
}

exit(0);
